import AuthService from '@/services/AuthService.js'
import axios from 'axios'
// import { state } from './products'
export const state = () => ({
  userisExist: null,
  userPhone: '',
  msg: '',
  IsUserAuthenticated: false,
  userdata: [],
  addressData:[]
})
export const getters = {
  GetUserisExist(state) {
    return state.userisExist
  },
  GetUserPhone(state) {
    return state.userPhone
  },
  GETMSG(state) {
    return state.msg
  },
  IsUserAuthenticated(state) {
    return state.IsUserAuthenticated
  },
  GetUserData(state) {
    return state.userdata
  },
  GetAddressData(state) {
    return state.userdata
  },
}
export const mutations = {
  USER_IS_Exist(state, data) {
    state.userisExist = data
  },
  SET_USER_PHONE(state, mobile) {
    state.userPhone = mobile
  },
  SET_MSG(state, msg) {
    state.msg = msg
  },
  SET_AUTH_COOKIE(state, loginResult) {
    this.$cookies.set('2sote_Auth_Token', loginResult.data.token, {
      path: '/',
      maxAge: 60 * 60 * 24 * 7,
    })
    axios.defaults.headers.common[
      'Authorization'
    ] = `Bearer ${loginResult.data.token}`
  },
  SET_USER_AUTHENTICATED(state, isAuth) {
    state.IsUserAuthenticated = isAuth
  },
  SET_USER_DATA(state, userdata) {
    state.userdata = userdata
  },
  DELETE_AUTH_COOKIE(){
    this.$cookies.remove('2sote_Auth_Token')
  },
  SET_ADDRESS_DATA(state) {
    return state.addressData
  },
  // SET_USER_DATA(state, userData) {
  //   localStorage.setItem('user', JSON.stringify(userData))
  //   axios.defaults.headers.common['Authorization'] = `Bearer ${userData.token}`
  //   state.user = userData
  // },
  // LOGOUT() {
  //   localStorage.removeItem('user')
  //   location.reload()
  // },
}
export const actions = {
  async UserisExist({ state, commit }, mobile) {
    try {
      await AuthService.accountCheck(mobile.mobile).then((response) => {
        console.log(response)
        if (response.status == 200) {
          commit('SET_USER_PHONE', mobile.mobile)
          commit('USER_IS_Exist', response.data.data.isExist)
          // if (response.data.data.isExist == true) {
          //   this.$router.push('/Verification')
          // } else {
          //   alert('jfbhjbejh')
          // }
        } else if (response.status == 400) {
          commit('SET_MSG', 'اطلاعات وارد شده صیحیح نمی باشد')
        }
      })
    } catch (err) {
      console.log(err)
    }
  },

  async Login({ state, commit }, loginData) {
    try {
      console.log(loginData)
      await AuthService.login(loginData).then((response) => {
        console.log(response)
        if (response.status == 200) {
          commit('SET_AUTH_COOKIE', response.data)
          commit('SET_USER_AUTHENTICATED', true)
          commit('SET_MSG', response.data.msg.text)
          // commit('USER_IS_Exist', response.data.data.isExist)
          // if (response.data.data.isExist == true) {
          //   this.$router.push('/Verification')
          // } else {
          //   alert('jfbhjbejh')
          // }
          console.log('hhhhhh')
        } else if (response.status == 400) {
          console(404)
        }
      })
    } catch (err) {
      console.log(err)
    }
  },

  async ForgetPassword({ state, commit }, mobile) {
    try {
      await AuthService.forgetPassword(mobile.mobile).then((response) => {
        console.log(response)
        if (response.status == 200) {
          commit('SET_MSG', response.data.msg.text)
          // if (response.data.data.isExist == true) {
          //   this.$router.push('/Verification')
          // } else {
          //   alert('jfbhjbejh')
          // }
        } else if (response.status == 400) {
          // commit('SET_MSG',response.data.msg.text)
        }
      })
    } catch (err) {
      console.log(err)
    }
  },
  // async UserProfile({ state, commit }) {
  //   try {
  //     await AuthService.userprofile().then((response) => {
  //       console.log(response)
  //       if (response.status == 200) {
  //         commit('SET_USER_DATA', response)
  //         commit('SET_USER_AUTHENTICATED', true)
  //       } else if (response.status == 400) {
  //         // commit('SET_MSG',response.data.msg.text)
  //       }
  //     })
  //   } catch (err) {
  //     console.log(err)
  //   }
  // },

  async UserProfile({ state, commit }) {
    var config = {
      method: 'GET',
      url: '/api/Account/UserProfile',
      headers: {
        Accept: 'text/plain',
        'Content-Type': 'application/json',
        Authorization: 'Bearer ' + this.$cookies.get('2sote_Auth_Token'),
      },
    }
    
    try {
      await axios(config).then((response) => {
        console.log(response)
        if (response.status == 200 && response.status !== 401) {
          commit('SET_USER_AUTHENTICATED', true)
          commit('SET_USER_DATA', response.data.data)
        }
      })
    } catch (err) {
    }
  },

  SignOutUser({commit}){
    commit('SET_USER_AUTHENTICATED', false);
    commit("DELETE_AUTH_COOKIE");
  },

  
  async addressAdd({ state, commit }, addressData) {
    try {
      await AuthService.AddAddress(addressData).then((response) => {
        console.log(response)
        if (response.status == 200) {
          // if (response.data.data.isExist == true) {
          //   this.$router.push('/Verification')
          // } else {
          //   alert('jfbhjbejh')
          // }
        } else if (response.status == 400) {
          commit('SET_MSG', 'اطلاعات وارد شده صیحیح نمی باشد')
        }
      })
    } catch (err) {
      console.log(err)
    }
  },


  
}
